const axios = require('axios')

const originalUrl = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4'

const masterServerIP = '172.16.1.121' // should be changed according to your installation
const adminSecrete = 'kCYqikHH5860' // should be changed according to your installation
const devProfileName = 'Developer'
const devProfileEmail = 'dev@example.com'
const baseURL = `http://${masterServerIP}`

const axiosInst = axios.create({ baseURL })
axiosInst.defaults.headers.common['Authorization'] = adminSecrete


const registerDeveloperProfile = async () => {
    try {
        const profile = {
            name: devProfileName,
            eMail: devProfileEmail,
            fetchFileUrl: `${baseURL}/api/mediafiles`,
            mediaTabContentUrl: `${baseURL}/api/mediafiles`,
            fetchThumbnailUrl: `${baseURL}/api/clip_thumbnail`
        }
        const resp = await axiosInst.post('/api/dev_profiles', profile)
        return resp.data.apiKey
    } catch (e) {
        throw Error(`Error registerDeveloperProfile: ${e}`)
    }
}

const processMediaInfo = async ({ apiKey, originalUrl }) => {
    try {
        const headers = { 'Authorization': apiKey }
        let resp = await axiosInst.post('/api/task/mediainfo', { originalUrl }, { headers })
        const id = resp.data.id
        do {
            resp = await axiosInst.get(`/api/task/mediainfo/${id}`, { headers })
        } while (resp.status === 202)
    } catch (e) {
        throw Error(`Error processMediaInfo: ${e}`)
    }
}

const registerUser = async ({ apiKey }) => {
    try {
        const user = {
            apiKey,
            apiAuthToken: apiKey
        }
        const resp = await axiosInst.post('/api/users', user)
        return resp.data.id
    } catch (e) {
        throw Error(`Error registerUser: ${e}`)
    }
}

const main = async () => {
    const apiKey = await registerDeveloperProfile()
    await processMediaInfo({ apiKey, originalUrl })
    const sessionId = await registerUser({apiKey})
    console.log(`open chrome with the url:  ${baseURL}?session_id=${sessionId}`)
}

main()
