<?php

$originalUrl = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4';
$masterServerIP = '172.16.1.121'; // should be changed according to your installation
$adminSecret = 'kCYqikHH5860'; // should be changed according to your installation
$devProfileName = 'Developer';
$devProfileEmail = 'dev@example.com';
$baseURL = "http://$masterServerIP";

function sendRequest($url, $method = 'GET', $data = null, $headers = null) {
    $ch = curl_init();
    // Disable SSL certificate verification (not recommended for production)
    curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
    curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);

    curl_setopt($ch, CURLOPT_URL, $url);
    curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
    curl_setopt($ch, CURLOPT_CUSTOMREQUEST, $method);

    if ($data !== null) {
        curl_setopt($ch, CURLOPT_POSTFIELDS, $data);
    }

    if ($headers !== null) {
        curl_setopt($ch, CURLOPT_HTTPHEADER, $headers);
    }

    $response = curl_exec($ch);

    if ($response === false) {
        throw new Exception("cURL error: " . curl_error($ch));
    }

    curl_close($ch);

    return $response;
}

function registerDeveloperProfile()
{
    global $baseURL,$adminSecret, $devProfileName, $devProfileEmail;

    $profile = [
        'name' => $devProfileName,
        'eMail' => $devProfileEmail,
        'fetchFileUrl' => "$baseURL/api/mediafiles",
        'mediaTabContentUrl' => "$baseURL/api/mediafiles",
        'fetchThumbnailUrl' => "$baseURL/api/clip_thumbnail",
    ];
    $headers = ['Authorization: ' . $adminSecret,
                'Content-Type: application/json'];
    $response = sendRequest("$baseURL/api/dev_profiles", 'POST', json_encode($profile), $headers);
    $data = json_decode($response, true);
    return $data['apiKey'];
}


function processMediaInfo($apiKey, $originalUrl)
{
    global $baseURL;

    $headers = ['Authorization: ' . $apiKey,
                'Content-Type: application/json'];

    $postData = [
        'originalUrl' => $originalUrl,
    ];
    $response = sendRequest("$baseURL/api/task/mediainfo", 'POST', json_encode(['originalUrl' => $originalUrl,]), $headers);
    $data = json_decode($response, true);
    $id = $data['id'];
    do {
        $response = sendRequest("$baseURL/api/task/mediainfo/$id", 'GET', null, $headers);
        $data = json_decode($response, true);
    } while (array_key_exists('status', $data));
}

function registerUser($apiKey)
{
    global $baseURL;

    $user = [
        'apiKey' => $apiKey,
        'apiAuthToken' => $apiKey,
    ];
    $headers = ['Content-Type: application/json'];
    $response = sendRequest("$baseURL/api/users", 'POST', json_encode($user), $headers);
    $data = json_decode($response, true);
    return $data['id'];
}

function main()
{
    try {
        $apiKey = registerDeveloperProfile();
        processMediaInfo($apiKey, $GLOBALS['originalUrl']);
        $sessionId = registerUser($apiKey);
        echo "open chrome with the url:  $GLOBALS[baseURL]?session_id=$sessionId";
    } catch (Exception $e) {
        echo 'Error: ' . $e->getMessage();
    }
}

main();

?>
