import requests

original_url = 'https://smarteditingonline.solveigmm.com/files/test_video.mp4'
master_server_ip = '172.16.1.121'  # should be changed according to your installation
admin_secret = 'kCYqikHH5860'  # should be changed according to your installation
dev_profile_name = 'Developer'
dev_profile_email = 'dev@example.com'
base_url = f'http://{master_server_ip}'

session = requests.Session()
session.headers.update({'Authorization': admin_secret})

def register_developer_profile():
    try:
        profile = {
            'name': dev_profile_name,
            'eMail': dev_profile_email,
            'fetchFileUrl': f'{base_url}/api/mediafiles',
            'mediaTabContentUrl': f'{base_url}/api/mediafiles',
            'fetchThumbnailUrl': f'{base_url}/api/clip_thumbnail'
        }
        resp = session.post(f'{base_url}/api/dev_profiles', json=profile)
        resp.raise_for_status()
        return resp.json()['apiKey']
    except requests.exceptions.RequestException as e:
        raise Exception(f'Error register_developer_profile: {e}')

def process_media_info(api_key, original_url):
    try:
        headers = {'Authorization': api_key}
        resp = session.post(f'{base_url}/api/task/mediainfo', json={'originalUrl': original_url}, headers=headers)
        task_id = resp.json()['id']

        while True:
            resp = session.get(f'{base_url}/api/task/mediainfo/{task_id}', headers=headers)
            if resp.status_code != 202:
                break
    except requests.exceptions.RequestException as e:
        raise Exception(f'Error process_media_info: {e}')

def register_user(api_key):
    try:
        user = {
            'apiKey': api_key,
            'apiAuthToken': api_key
        }
        resp = session.post(f'{base_url}/api/users', json=user)
        resp.raise_for_status()
        return resp.json()['id']
    except requests.exceptions.RequestException as e:
        raise Exception(f'Error register_user: {e}')

def main():
    api_key = register_developer_profile()
    process_media_info(api_key, original_url)
    session_id = register_user(api_key)
    print(f'Open Chrome with the URL: {base_url}?session_id={session_id}')

if __name__ == '__main__':
    main()